// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.component.UITreeSelect;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeSelectTagDeclaration}.
 */
public final class TreeSelectTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(TreeSelectTag.class);
  private javax.el.ValueExpression  validatorMessage;
  private javax.el.ValueExpression  markup;
  private javax.el.MethodExpression  valueChangeListener;
  private javax.el.ValueExpression  converter;
  private javax.el.ValueExpression  label;
  private javax.el.ValueExpression  required;
  private javax.el.ValueExpression  showCheckbox;
  private javax.el.ValueExpression  tip;
  private javax.el.ValueExpression  disabled;
  private javax.el.ValueExpression  converterMessage;
  private javax.el.ValueExpression  value;
  private javax.el.ValueExpression  requiredMessage;

  @Override
  public String getComponentType() {
    return UITreeSelect.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "TreeSelect";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UITreeSelect component = (UITreeSelect) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (validatorMessage != null) {
      component.setValueExpression("validatorMessage", validatorMessage);
    }

    if (markup != null) {
      if (!markup.isLiteralText()) {
        component.setValueExpression("markup", markup);
      } else {
        component.setMarkup(org.apache.myfaces.tobago.context.Markup.valueOf(markup.getExpressionString()));
      }
    }
    if (valueChangeListener != null) {
      component.addValueChangeListener(new javax.faces.event.MethodExpressionValueChangeListener(valueChangeListener));
    }
    if (converter != null) {
      if (!converter.isLiteralText()) {
        component.setValueExpression("converter", converter);
      } else {
        component.setConverter(application.createConverter(converter.getExpressionString()));
      }
    }
    if (label != null) {
      component.setValueExpression("label", label);
    }

    if (required != null) {
      if (!required.isLiteralText()) {
        component.setValueExpression("required", required);
      } else {
        component.setRequired(Boolean.parseBoolean(required.getExpressionString()));
      }
    }
    if (showCheckbox != null) {
      if (!showCheckbox.isLiteralText()) {
        component.setValueExpression("showCheckbox", showCheckbox);
      } else {
        component.setShowCheckbox(Boolean.parseBoolean(showCheckbox.getExpressionString()));
      }
    }
    if (tip != null) {
      component.setValueExpression("tip", tip);
    }

    if (disabled != null) {
      if (!disabled.isLiteralText()) {
        component.setValueExpression("disabled", disabled);
      } else {
        component.setDisabled(Boolean.parseBoolean(disabled.getExpressionString()));
      }
    }
    if (converterMessage != null) {
      component.setValueExpression("converterMessage", converterMessage);
    }

    if (value != null) {
      component.setValueExpression("value", value);
    }

    if (requiredMessage != null) {
      component.setValueExpression("requiredMessage", requiredMessage);
    }

  }

  public javax.el.ValueExpression getValidatorMessage() {
    return validatorMessage;
  }

  public void setValidatorMessage(final javax.el.ValueExpression validatorMessage) {
    this.validatorMessage = validatorMessage;
  }

  public javax.el.ValueExpression getMarkup() {
    return markup;
  }

  public void setMarkup(final javax.el.ValueExpression markup) {
    this.markup = markup;
  }

  public javax.el.MethodExpression getValueChangeListener() {
    return valueChangeListener;
  }

  public void setValueChangeListener(final javax.el.MethodExpression valueChangeListener) {
    this.valueChangeListener = valueChangeListener;
  }

  public javax.el.ValueExpression getConverter() {
    return converter;
  }

  public void setConverter(final javax.el.ValueExpression converter) {
    this.converter = converter;
  }

  public javax.el.ValueExpression getLabel() {
    return label;
  }

  public void setLabel(final javax.el.ValueExpression label) {
    this.label = label;
  }

  public javax.el.ValueExpression getRequired() {
    return required;
  }

  public void setRequired(final javax.el.ValueExpression required) {
    this.required = required;
  }

  public javax.el.ValueExpression getShowCheckbox() {
    return showCheckbox;
  }

  public void setShowCheckbox(final javax.el.ValueExpression showCheckbox) {
    this.showCheckbox = showCheckbox;
  }

  public javax.el.ValueExpression getTip() {
    return tip;
  }

  public void setTip(final javax.el.ValueExpression tip) {
    this.tip = tip;
  }

  public javax.el.ValueExpression getDisabled() {
    return disabled;
  }

  public void setDisabled(final javax.el.ValueExpression disabled) {
    this.disabled = disabled;
  }

  public javax.el.ValueExpression getConverterMessage() {
    return converterMessage;
  }

  public void setConverterMessage(final javax.el.ValueExpression converterMessage) {
    this.converterMessage = converterMessage;
  }

  public javax.el.ValueExpression getValue() {
    return value;
  }

  public void setValue(final javax.el.ValueExpression value) {
    this.value = value;
  }

  public javax.el.ValueExpression getRequiredMessage() {
    return requiredMessage;
  }

  public void setRequiredMessage(final javax.el.ValueExpression requiredMessage) {
    this.requiredMessage = requiredMessage;
  }



  @Override
  public void release() {
    super.release();
    validatorMessage = null;
    markup = null;
    valueChangeListener = null;
    converter = null;
    label = null;
    required = null;
    showCheckbox = null;
    tip = null;
    disabled = null;
    converterMessage = null;
    value = null;
    requiredMessage = null;
  }
}